require 'safe_yaml'
SafeYAML::OPTIONS[:default_mode] = :safe

require 'nos_oignons/reminder_db'

module NosOignons
  MEMBER_FIELDS = [:name, :address, :email, :joined_on, :membership_fee_paid_on]
  MEMBER_MANDATORY_FIELDS = [:name, :email]
  # Directory in the board wiki which holds the member pages
  MEMBERS_DB_DIR = 'Membres'

  class Member < Struct.new(*MEMBER_FIELDS)
    class << self
      def db_path
        if ENV['NOS_OIGNONS_BOARD_WIKI_PATH']
          @db_path = File.join(ENV['NOS_OIGNONS_BOARD_WIKI_PATH'], MEMBERS_DB_DIR)
        else
          return @db_path if @db_path

          git_path = `git rev-parse --show-toplevel`.strip
          if File.exists?(File.join(git_path, MEMBERS_DB_DIR))
            @db_path = File.join(git_path, MEMBERS_DB_DIR)
          else
            @db_path = File.join(File.expand_path('../wiki-ca', git_path), MEMBERS_DB_DIR)
          end
        end
        @db_path
      end

      def all
        Dir.glob("#{db_path}/*.mdwn").sort.collect do |file|
          member_id = File.basename(file).gsub(/\.mdwn$/, '')
          Member.new(member_id)
        end
      end

      def filename_for_id(member_id)
        case member_id
        when String
          "#{NosOignons::Member.db_path}/#{member_id}.mdwn"
        when Integer
          "#{NosOignons::Member.db_path}/%06d.mdwn" % member_id
        end
      end

      def read_from_git(ref, file)
        IO.popen(['git', 'show', "#{ref}:#{file}"]) do |f|
          member_id = File.basename(file).gsub(/\.mdwn$/, '')
          Member.new(member_id, f.read)
        end
      end
    end

    attr_reader :member_id

    def initialize(member_id, page_content=nil)
      unless member_id =~ /\A\d{6}\z/
        raise ArgumentError.new('bad member id format')
      end
      @member_id = member_id
      unless page_content
        begin
          page_content = File.open(Member.filename_for_id(member_id)).read
        rescue Errno::ENOENT
          raise ArgumentError.new('unknown member')
        end
      end
      unless page_content.start_with?("---\n")
        raise ArgumentError.new('content is not a proper YAML document')
      end
      yaml_content = /\A---\n(.*)\n---\n/m.match(page_content)[1]
      data = YAML.load(yaml_content)
      MEMBER_FIELDS.each do |field|
        self[field] = data[field.to_s]
      end
      # Immutability for the win
      MEMBER_FIELDS.each do |field|
        instance_eval{ undef :"#{field}=" }
      end
      MEMBER_MANDATORY_FIELDS.each do |sym|
        raise ArgumentError.new('missing mandatory fields') unless self[sym]
      end
      [:joined_on, :membership_fee_paid_on].each do |sym|
        if self[sym] && !self[sym].is_a?(Date)
          raise ArgumentError.new("#{sym.to_s} is not a date")
        end
      end
    end

    def up_to_date?
      return false if !joined_on || !membership_fee_paid_on

      today = Time.now.to_date
      expire_on = Time.new(membership_fee_paid_on.year + 1, joined_on.month, joined_on.day).to_date
      today <= expire_on
    end

    def remind(reminder)
      reminder.send(self)
      ReminderDb.instance.record(self)
    end

    def reminded_on
      ReminderDb.instance.last_reminder(self)
    end

    def create_receipt!(amount)
      require 'nos_oignons/receipt'

      receipt = Receipt.new(self, amount)
      receipt.create!
    end
  end
end
